(function () {
  var version = '1.0.0';//版本号 发布新版本时请保持当前版本号与服务器上check-android-version.jsp中版本号一致。并修改所有旧版本中的check-android-version.jsp以提示用户存在新版本
 // var origin = 'http://care2017.longser.com/app';//本地域名
  var origin = 'http://careapp.51gh.com.cn';//正式域名
  var chcpUrl = origin + '/www/chcp.json';//cordova-hcp 版本控制json文件地址
  var versionUrl = origin + '/api/user/check-android-version.jsp';//大版本控制文件地址
  var rollbackKey = 'careapp.rollback';
  var rollback = localStorage.getItem(rollbackKey) || false;//回滚
  var BundleId = "com.longser.care.app";//应用ID 与config.xml中对应 iOS系统中专用

  var Splashscreen;//启动页
  var Dialogs;//提示窗
  var AppExit;//应用退出
  var Network;//联网情况
  var BetaPath;//外部文件地址
  var Platform;//平台

  /**
   * 错误处理 详情见https://github.com/nordnet/cordova-hot-code-push/wiki/Error-codes
   *   2: NOTHING_TO_UPDATE
   *   1: NOTHING_TO_INSTALL
   *  -1: FAILED_TO_DOWNLOAD_APPLICATION_CONFIG
   *  -2: APPLICATION_BUILD_VERSION_TOO_LOW
   *  -3: FAILED_TO_DOWNLOAD_CONTENT_MANIFEST
   *  -4: FAILED_TO_DOWNLOAD_UPDATE_FILES
   *  -5: FAILED_TO_MOVE_LOADED_FILES_TO_INSTALLATION_FOLDER
   *  -6: UPDATE_IS_INVALID
   *  -7: FAILED_TO_COPY_FILES_FROM_PREVIOUS_RELEASE
   *  -8: FAILED_TO_COPY_NEW_CONTENT_FILES
   *  -9: LOCAL_VERSION_OF_APPLICATION_CONFIG_NOT_FOUND
   * -10: LOCAL_VERSION_OF_MANIFEST_NOT_FOUND
   * -11: LOADED_VERSION_OF_APPLICATION_CONFIG_NOT_FOUND
   * -12: LOADED_VERSION_OF_MANIFEST_NOT_FOUND
   * -13: FAILED_TO_INSTALL_ASSETS_ON_EXTERNAL_STORAGE
   * -14: CANT_INSTALL_WHILE_DOWNLOAD_IN_PROGRESS
   * -15: CANT_DOWNLOAD_UPDATE_WHILE_INSTALLATION_IN_PROGRESS
   * -16: INSTALLATION_ALREADY_IN_PROGRESS
   * -17: DOWNLOAD_ALREADY_IN_PROGRESS
   * -18: ASSETS_FOLDER_IS_NOT_YET_INSTALLED
   * -19: NEW_APPLICATION_CONFIG_IS_INVALID
   * 不需要回退，需退出应用：-9, -11, -12,-18
   * 服务器繁忙，需推出应用：-1, -3, -4, 
   * 不需处理：1,2,-2,-13,-18,-14, -15,-16, -17,
   * 需要回退并退出应用：-5,-6,-7,-8,-10,-19
   */

  var ServerErrCode = [-1, -3, -4];
  var ExitErrCode = [-9, -11, -12, -18];
  var RollbackAndExitErrCode = [-5, -6, -7, -8, -10, -19];

  /**设备就绪**/
  document.addEventListener('deviceready', function () {
    Splashscreen = navigator.splashscreen;
    Dialogs = navigator.notification;
    AppExit = plugins.app;
    Platform = device.platform;
    Network = navigator.connection;

    //防止异步执行时部分参数获取不到的问题
    setTimeout(function () {
      if (Platform === "iOS") {
        BetaPath = cordova.file.applicationStorageDirectory + 'Library/Application Support/' + BundleId + '/cordova-hot-code-push-plugin/';
      } else {
        BetaPath = cordova.file.dataDirectory + 'cordova-hot-code-push-plugin/';//dataDirectory->file:///data/user/0/appid/files/
      }

      // console.log('BetaPath', BetaPath);
      // checkDir(BetaPath);//遍历文件夹

      /**网络检查 */
      if (Network.type == 'none') {
        Splashscreen.hide();
        //console.log('设备未联网，请联网后重试');
        // Dialogs.alert('设备未联网，请联网后重试', function () {
        //   exitApp();
        // }, '温馨提示', '确定');
        return;
      }

      //网络请求检查大版本是否需要更新
      httpGet(versionUrl, function (data) {
        if (data.errcode == undefined) {//成功获取到version版本号
          if (version != data.version) {
            Dialogs.alert('应用有新版本，请前往应用商店更新下载。', null, '温馨提示', '确定');
          }
        }
        checkUpdate();
      }, 5000);
    }, 0);

    //第一次安装应用复制至外部存储空间失败 errcode:-13
    document.addEventListener('chcp_assetsInstallationError', function (data) {
      //console.log('chcp_assetsInstallationError', data);
      Dialogs.alert('存储空间不足，请清理手机空间后重新下载安装', function () {
        exitApp();
      }, '温馨提示', '确定');
    }, false);

    //获取配置文件失败
    document.addEventListener('chcp_updateLoadFailed', function (error) {
      //console.log('获取配置文件失败', error);
      Splashscreen.hide();
    }, false);

    //新文件下载完成，未安装
    document.addEventListener('chcp_updateIsReadyToInstall', function (data) {
      //console.log('chcp_updateIsReadyToInstall', data);
      Splashscreen.hide();
    }, false);


    //无新文件下载且无新文件安装
    document.addEventListener('chcp_nothingToUpdate', function (data) {
      //console.log('chcp_nothingToUpdate', data);
      Splashscreen.hide();
    }, false);
  }, false);

  /**
   * http请求
   * @param {*} url 地址
   * @param {*} callback 回调
   * @param {*} time 超时时间
   */
  function httpGet(url, callback, time) {
    var request = new XMLHttpRequest();
    var timeout = false;
    var time = time || 0;

    var timer = setTimeout(function () {
      timeout = true;
      request.abort();
    }, time);

    request.open("GET", url);
    request.onreadystatechange = function () {
      if (request.readyState !== 4) {
        return;
      }

      if (timeout) {
        callback({
          errcode: -1,
          errmsg: 'timeout'
        });//报错
        return;
      }

      if (request.status === 200) {
        clearTimeout(timer);
        callback(JSON.parse(request.responseText));
      }
    }
    request.send();
  }

  /**
   * 检查更新
   */
  function checkUpdate() {
    //检查回滚标记判断是否需要回滚
    if (rollback === 'true') {
      removeDir(BetaPath);
    } else {
      /**检查是否有需要安装的更新 */
      chcp.isUpdateAvailableForInstallation(function (error) {
        localStorage.setItem(rollbackKey, true);//设置回滚标记

        if (error) {//没有需要安装的更新
          //console.log('Nothing to install. Executing fetch.', error);
          var options = {
            'config-file': chcpUrl,
            'request-headers': {
              'Pragma': 'no-cache',
              'Expires': '0',
              'Cache-Control': 'no-cache'
            }
          };
          chcp.fetchUpdate(fetchUpdateCallback, options);//检查更新
          return;
        }

        chcp.installUpdate(installationCallback);//安装更新
      });
    }
  }

  /**
   * 检查更新回调
   * @param {*} error 异常
   */
  function fetchUpdateCallback(error) {
    //console.log('fetchUpdateCallback result', error);
    // alert('fetchUpdateCallback'+JSON.stringify(error));
    if (error) {//下载失败或无下载
      var errcode = error.code;
      if (ServerErrCode.indexOf(errcode) > -1) {
        localStorage.setItem(rollbackKey, false);
        Dialogs.alert('服务器繁忙，请稍后重试', function () {
          exitApp();
        }, '温馨提示', '确定');
      } else if (ExitErrCode.indexOf(errcode) > -1) {
        localStorage.setItem(rollbackKey, false);
        Dialogs.alert('启动失败，请重启应用', function () {
          exitApp();
        }, '温馨提示', '确定');
      } else if (RollbackAndExitErrCode.indexOf(errcode) > -1) {
        removeDir(BetaPath);
      } else {
        localStorage.setItem(rollbackKey, false);
      }
    } else {//下载成功
      localStorage.setItem(rollbackKey, false);
      Dialogs.alert('应用有更新，重启安装更新', function () {
        exitApp();
      }, '温馨提示', '确定');
    }
  }

  /**
   * 安装更新回调
   * @param {*} error 异常
   */
  function installationCallback(error) {
    if (error) {//安装失败
      //console.log('installationCallback error', error);
      var errcode = error.code;
      if (ServerErrCode.indexOf(errcode) > -1) {
        Dialogs.alert('服务器繁忙，请稍后重试', function () {
          exitApp();
        }, '温馨提示', '确定');
      } else if (ExitErrCode.indexOf(errcode) > -1) {
        localStorage.setItem(rollbackKey, false);
        Dialogs.alert('启动失败，请重启应用', function () {
          exitApp();
        }, '温馨提示', '确定');
      } else if (errcode in RollbackAndExitErrCode) {
        removeDir(BetaPath);
      }
    } else {//下载成功
      localStorage.setItem(rollbackKey, false);
      //console.log('Update installed!');
    }
  }

  /**
   * 删除文件夹
   * @param {*} dirName 目录
   */
  function removeDir(dirName) {
    resolveLocalFileSystemURL(dirName, function (fileSystem) {
      fileSystem.removeRecursively(function (data) {
        //console.log('removeDir success', data);
        Dialogs.alert('更新失败，请重启应用', function (data) {
         // console.log('更新失败', data);
          localStorage.setItem(rollbackKey, false);
          exitApp();
        }, '温馨提示', '确定');
      }, function (error) {
        //console.log('removeDir error', error);
        Dialogs.alert('更新失败，请重启应用', function () {
          exitApp();
        }, '温馨提示', '确定');
      });
    })
  }

  /**
   * 遍历文件夹
   * @param {*} dirName 目录
   */
  function checkDir(dirName) {
    resolveLocalFileSystemURL(dirName, function (dirEntry) {
      //显示根目录下的内容  
      var dirReader = dirEntry.createReader();
      var entries = [];
      var readEntries = function () {
        //返回FileEntry数组  
        dirReader.readEntries(function (results) {
          if (!results.length) {
            showEntries(entries.sort());
          } else {
            entries = entries.concat(toArray(results));
            readEntries();
          }
        }, errorHandler);
      }
      readEntries();
    });

    function errorHandler(err) {
      console.info(err);
    }
    function toArray(list) {
      return Array.prototype.slice.call(list || [], 0);
    }
    //显示读取结果  
    function showEntries(entries) {
      console.info(entries);
    }
  }

  /**
   * 读取文件
   * @param {*} fileEntry 文件路径
   */
  function readFile(fileEntry) {
    fileEntry.file(function (file) {
      var reader = new FileReader();
      reader.onloadend = function () {
        //console.log(this.result);
      };
      reader.readAsText(file);
    }, function (err) {
      //console.log("文件读取失败!", err);
    });
  }

  /**
   * 退出app
   */
  function exitApp() {
    AppExit.exit({
      "platform": Platform
    });
  }

})();